
package gui;

public class HexBoard {

    // print to stdout not allowed in gtp-dummy
    public boolean allowPrint=true;

    // consts
    public static final int EMPTY = 0;
    public static final int BLACK = 1;
    public static final int WHITE = 2;

    public int game_turn=BLACK;                 // whose turn is it?

    // ****************************************************************
    // ****************************************************************

    public int f[][]; // the playing field

    public int board_size;  // length of one edge    (=10 for example)

    // *************************************  // FOR DETERMINING A WIN: (MAINLY)

    private int frec[][];   // INTERNAL: field for determining a win
    //final int neighb[][] = { {1,0}, {0,1}, {0,-1}, {-1,0}, {0,-1}, {1,-1} };           // neighbours
    final int neighb[][] = { {1,0}, {0,1}, {-1,1}, {-1,0}, {0,-1}, {1,-1} }; // neighbours
    // *************************************



    public HexBoard(int board_size){ // board_size=10 for example
        newGame(board_size);
    }


    // clear the board and clear the movelist
    public void newGame(int board_size) { // board_size=10 for example
        this.board_size = board_size;

        clearBoard();

        game_turn=BLACK;
    }

    // INTERNAL: only clear the board, but keep movelist
    private void clearBoard(){ // board_size=10 for example
        f    = new int[board_size][board_size]; // the board
        frec = new int[board_size][board_size]; // for determining a win

        for(int x = 0; x < board_size; x++)
            for(int y = 0; y < board_size; y++)
                f[x][y] = EMPTY;

        game_turn=BLACK;
        // move_history.clear();
        // lastMove = null;// not needed anymore by hgui
        //************************** SET UP VARIABLES for this boardboard_size
    }

    // **********************************************************************************

    // needed by hgui (for painting)
    public int getSize() {
        return board_size;
    }

    // get value of a board position
    public int getValue(int x, int y){
        if(! isOnBoard(x,y)) return EMPTY;

        return f[x][y];
    }

    // ********************************************************************************** set Value on Board

    // change a value on the board
    public boolean setValue (int x, int y, int value){
        if (!isOnBoard(x,y)) return false;
        if ((value!=BLACK) && (value!=WHITE) && (value!=EMPTY)) return false;

        f[x][y] = value;


        return true;
    }


    // **********************************************************************************
    // **************** Code to determine whether a position is won *********************
    // **********************************************************************************

    // board_size default = 10
    public static boolean isOnBoard(int board_size, int x, int y)
    {
        return (x>=0 && y>=0 && x<board_size && y<board_size);
    }

    public boolean isOnBoard(int x,int y)
    {
        return isOnBoard(board_size, x, y);
    }

    // only for bits 0..5
    public int numbitsset(int var)
    {
        int n=0, b=1;
        for(int k=0;k<6;k++){
            if ((var & b) != 0) n++;
            b=b<<1;
        }
        return n;
    }

    //****************************************************************************


    // *********************************************************************************************

} // END CLASS
